/* File splitter program

   Ankit Rohatgi             
   ankit@ankitrohatgi.com    Splitf v1.0
   www.ankitrohatgi.com      
   DATED : 22nd March 2001
   LINES : 306
*/
#include<conio.h>
#include<sys\stat.h>
#include<fstream.h>
#include<dos.h>
#include<stdio.h>
#include<io.h>
#include<process.h>
#include<string.h>
int ptx=0;
struct spltf
{ char ID[5];
  char f_name[14];
  unsigned int parts;
};
struct finf
{ char f_name[14];
  long int size;
};
spltf split;
finf fili;
void progress(int pt,int stat);
void textxy(int x1,int y1,char *t);
void intxy(int x1,int y1,long int t);
void rectangle(int x1,int y1,int x2,int y2);
void intext(char *t,char *&a);
void inint(char *t,long int &a);
void Cl();
void splitfl();
void combfl();
void fatalE(char *t);
void end()
{ Cl();
  textcolor(10);
  textxy(2,9,"Thank you for using SPLITF v1.0.  DATED : 22nd Mar 2001");
  textxy(2,10,"Made by : Ankit Rohatgi.");
  textxy(2,11,"Website : www.ankitrohatgi.com ");
  getch();
  clrscr();
  exit(1);
}
long int mainmenu()
{ clrscr();
  textcolor(14);
  rectangle(1,1,79,3);
  textcolor(15);
  textxy(30,2,"File splitter v1.0");
  textcolor(9);
  rectangle(1,5,79,20);
  textcolor(2);
  rectangle(1,21,79,25);
  textcolor(10);
  textxy(33,7,"MAIN MENU");
  textcolor(12);
  textxy(30,8,"1. Split a file");
  textxy(30,9,"2. Combine split files");
  textxy(30,10,"3. Exit");
  long int opt;
  progress(0,1);
  textcolor(15);
  do
  {inint("Enter option : ",opt);
  } while((opt<1)||(opt>3));
  Cl();
  switch(opt)
  { case 1: splitfl();break;
    case 2: combfl();break;
    case 3:break;
    default:exit(1);break;
  }
  return(opt);
}

void main()
{ long int r;
  do
  {r=mainmenu();}while(r!=3);
  end();
}

void textxy(int x1,int y1,char *t)
{ gotoxy(x1,y1);
  cprintf(t);
}
void intxy(int x1,int y1,long int t)
{ gotoxy(x1,y1);
  cprintf("%li",t);
}

void progress(int pt,int stat)
{ if(stat==1)
  { textcolor(1);
    for(int i=15;i<=65;i++)
    { gotoxy(i,4);
      cprintf("%c",219);
    }
    ptx=0;
  }
  else
  { textcolor(4);
    if(ptx!=pt/2)
    { for(int i=15+ptx;i<=15+pt/2;i++)
      { gotoxy(i,4);
	cprintf("%c",219);
      }
      ptx=pt/2+1;
    }
  }

}
void rectangle(int x1,int y1,int x2,int y2)
{ gotoxy(x1,y1);
  cprintf("%c",218);
  gotoxy(x2,y1);
  cprintf("%c",191);
  gotoxy(x1,y2);
  cprintf("%c",192);
  gotoxy(x2,y2);
  cprintf("%c",217);
  for(int i=x1+1;i<x2;i++)
  { gotoxy(i,y1); cprintf("%c",196);
    gotoxy(i,y2); cprintf("%c",196);
  }
  for(i=y1+1;i<y2;i++)
  { gotoxy(x1,i); cprintf("%c",179);
    gotoxy(x2,i); cprintf("%c",179);
  }
}

void intext(char *t,char *&a)
{ window(2,22,78,24);
  clrscr();
  window(1,1,79,25);
  textxy(3,23,t);
  cin>>a;
}
void inint(char *t,long int &a)
{ window(2,22,78,24);
  clrscr();
  window(1,1,79,25);
  textxy(3,23,t);
  cin>>(long int)a;
}
void Cl()
{ window(2,6,78,19);
  clrscr();
  window(1,1,80,25);
}

void splitfl()
{ textxy(2,7,"Splitting a file to 2 or more files....");
  char f[80];
   lab01:
   intext("Enter filename (without path): ",f);
   ifstream infile(f,ios::in|ios::binary);
   if(!infile) { textxy(2,8,"File not found !");goto lab01; }
  long int remain,size=0,parts,sz;
  int pr=0;
  unsigned char ch;
  struct stat s01;
  stat(f,&s01);
  size=(long int)s01.st_size;
  if(size==0) {textxy(2,8,"File size is zero. Cannot split.");infile.close();goto lab01;}
  textxy(2,9,"Total Size : ");cout<<size<<" Bytes";
  remain=size;
  textxy(40,9,"Remaining size : ");cout<<remain<<" Bytes";
  lab03:
  inint("Enter number of parts : ",parts);
  if(parts<=0) {goto lab03;}
  char kf[14];
  textxy(2,10,"Total parts : ");cout<<parts;
  textxy(40,10,"Remaining parts : ");cout<<parts;
  textxy(2,12,"NOTE : Key file contains Imortant data");
  intext("Enter name of key file : ",kf);
  ofstream okf(kf,ios::out|ios::binary);
  if(!okf) {fatalE("File creation error !"); }
  strcpy(split.f_name,f);
  split.parts=parts;
  strcpy(split.ID,"SPCK");
  okf.write((char*)&split,sizeof(split));
  char f2[14];
  for(long int i=1;i<=parts,remain>0;i++)
  { textxy(2,14,"File : ");intxy(9,14,i);
    intext("Enter file name (without path): ",f2);
    if(i!=parts)
    { lab04:
      inint("Enter size in bytes : ",sz);
      if(sz>remain) {goto lab04;}
    }
    else{sz=remain;}
    ofstream of(f2,ios::out|ios::binary);
    if(!(of||okf)) { fatalE("File creation error !"); }
    strcpy(fili.f_name,f2);
    fili.size=sz;
    okf.write((char*)&fili,sizeof(fili));
    long int zz=1;
    char bigbuff[10240]; // 10 KB buffer
    char buff[1024]; // 1 KB buffer
    progress(0,1);
    while((zz<=sz)&&(infile)&&(remain>0))
    { if((remain>10240)&&((sz-zz)>10240))
      { infile.read((char*)&bigbuff,sizeof(bigbuff));
	of.write((char*)&bigbuff,sizeof(bigbuff));
	remain-=10240;zz+=10240;
      }
      else if((remain>1024)&&((sz-zz)>1024))
      { infile.read((char*)&buff,sizeof(buff));
	of.write((char*)&buff,sizeof(buff));
	remain-=1024;zz+=1024;
      }
      else
      { infile.read((char*)&ch,sizeof(ch));
	of.write((char*)&ch,sizeof(ch));
	remain--;zz++;
      }
      progress((zz*100)/sz,0);
    }
    textcolor(15);
    of.close();
    Cl();
    textxy(2,7,"Filename : ");textxy(13,7,f);
    textxy(2,8,"Total size : ");cout<<size<<" Bytes";
    textxy(40,8,"Remaining size : ");cout<<remain<<" Bytes";
    textxy(2,9,"Total parts : ");cout<<parts;
    textxy(40,9,"Remaining parts : ");cout<<parts-i;
    if((parts-i)<0) {infile.close();okf.close();fatalE("Unknown error !");}
    progress(0,1);
    textcolor(15);
  }
  okf.close();
  infile.close();
  Cl();
  textxy(2,9,"File split completed !");
  textxy(2,10,"Total files created : ");cout<<parts<<" +1";
  getch();

}
void combfl()
{ Cl();
  textxy(2,9,"Combine split files...");
  char kf[14];
  unsigned char ch;
  lab05:
  intext("Enter name of Key file : ",kf);
  textxy(2,10,"Combining.....");
  ifstream ikf(kf,ios::in|ios::binary);
  if(!ikf) { textxy(2,11,"File not found !!"); goto lab05;}
  else {textxy(2,11,"                      ");}
  ikf.read((char*)&split,sizeof(split));
  if(strcmp(split.ID,"SPCK")!=0) {ikf.close(); fatalE("Invalid Keyfile !");}
  ofstream mf(split.f_name,ios::out|ios::binary);
  long int i=1;
  int pr;
  while(i<=split.parts)
  { ikf.read((char*)&fili,sizeof(fili));
    ifstream f1(fili.f_name,ios::in|ios::binary);
    textcolor(15);
    textxy(2,11,"File : ");textxy(10,11,fili.f_name);
    if(!f1) { fatalE("File not found !!");}
    char bigbuff[10240]; // 10 KB buffer
    char buff[1024];     // 1 KB buffer
    progress(0,1);
    for(long int j=1;j<=fili.size;j++)
    { if((fili.size-j)>10240)
      { f1.read((char*)&bigbuff,sizeof(bigbuff));
	mf.write((char*)&bigbuff,sizeof(bigbuff));
	j+=10239;
      }
      else if((fili.size-j)>1024)
      { f1.read((char*)&buff,sizeof(buff));
	mf.write((char*)&buff,sizeof(buff));
	j+=1023;
      }
      else
      {   f1.read((char*)&ch,1);
	  mf.write((char*)&ch,1);
      }
      progress((j*100)/fili.size,0);
    }
    progress(0,1);
    f1.close();
    i++;
    textxy(2,11,"                                  ");
  }
  ikf.close();
  mf.close();
  progress(0,1);textcolor(15);
  textxy(2,11,"Task completed.");
  textxy(2,12,"Files combined to : ");
  textxy(22,12,split.f_name);
  getch();
  Cl();
}
void fatalE(char *t)
{ clrscr();
  cprintf("SPLITF v1.0  FATAL ERROR : \n");
  cprintf(t);
  exit(1);
}